DECLARE SUB Begin ()                'beginakties van het programma
DECLARE SUB BeginScherm ()          'welkomst-scherm, korte uitleg van programma
DECLARE SUB Diagonaal ()            'spiegel doolhof over de diagonaal
DECLARE SUB F1HogeMuren ()          'overgang Gewoon <--> HogeMuren
DECLARE SUB F2Blind ()              'overgang Gewoon <--> Blind
DECLARE SUB HoofdMenu ()            'kiezen spelnivo, akties per nivo
DECLARE SUB Horizontaal (X%, Y%)    'neerzetten horizontaal streepje
DECLARE SUB LeesDol ()              'lezen gekozen doolhof
DECLARE SUB LijstDol ()             'lezen doolhoven in directory
DECLARE SUB LinksRechts ()          'spiegel doolhof van links nr rechts
DECLARE SUB OndersteBoven ()        'keer doolhof ondersteboven
DECLARE SUB PijltjesToetsen ()      'afhandelen pijltjes toetsen
DECLARE SUB SchermTekenen ()        'opbouwen doolhof op scherm
DECLARE SUB SchermTeksten ()        'vaste teksten op scherm
DECLARE SUB Seconde ()              'telling per seconde
DECLARE SUB SleutelRondje (X%, Y%)  'neerzetten Sleutel of Rondje
DECLARE SUB TonenLijst ()           'tonen doolhoven van gekozen nivo
DECLARE SUB Verticaal (X%, Y%)      'neerzetten verticaal streepje
DECLARE SUB ZetHaalBlind ()         'neerzetten/weghalen muren bij Blind
DECLARE SUB ZetHaalHogeMuren ()     'neerzetten/weghalen muren bij HogeMuren
DECLARE SUB ZetHaalLoper (X%, Y%)   'neerzetten/weghalen loper
DECLARE SUB ZetHaalRondje (X%, Y%)  'neerzetten/weghalen rondje
DECLARE SUB ZetHaalSleutel (X%, Y%) 'neerzetten/weghalen sleutel
DECLARE SUB ZetNeerHaalWeg ()       'neerzetten/weghalen loper en evt. sleutel
DECLARE SUB ZetPunten ()            'punten telling op scherm

DEFINT A-Z
DIM SHARED Dolen1$(100)             'doolhoven 1
DIM SHARED Dolen2$(100)             '          2
DIM SHARED Dolen3$(100)             '          3
DIM SHARED Dolen$(100)              'lijst waarmee gewerkt wordt
DIM SHARED Hor(-3 TO 39, -3 TO 39)  'horizontale streepjes aan(1)  uit(0)
DIM SHARED Ver(-3 TO 39, -3 TO 39)  'verticale   streepjes aan(1)  uit(0)
DIM SHARED Sleutels(-3 TO 39, -3 TO 39)   'sleutelplaatsen
DIM SHARED Sleutel(300)             'GET / PUT sleutel
DIM SHARED Loper(300)               'GET / PUT witte vakje
DIM SHARED Rondje(300)              'GET / PUT witte rondje

DIM SHARED AantVakjes               '20, 27 of 36
DIM SHARED BeginX, BeginY, EindeX, EindeY 'coordinaten begin- en eindepunt
DIM SHARED LoperX, LoperY, LengteX, LengteY
DIM SHARED DoolNaam$, SpelNivo, BestandsNaam$
DIM SHARED AantDolen, AantDolen1, AantDolen2, AantDolen3
DIM SHARED Punten, MuurPunten, SecondePunten
DIM SHARED SleutelsMee, SleutelGebruiken, Blind, HogeMuren, EindeSpel
DIM SHARED Woord$, Rechts$, Links$, Omhoog$, Omlaag$, F1$, F2$, Esc$
DIM SHARED TijdOud$
DIM SHARED VoorgrondKleur           'wit (15, neerzetten) of zwart (0, weghalen)

CALL Begin
CALL BeginScherm
CALL LijstDol
verder1:
   CALL HoofdMenu
   IF SpelNivo = 4 THEN END
   CALL TonenLijst         'laat doolhof kiezen
   CALL LeesDol            'inlezen doolhof
   CALL SchermTekenen      'scherm opbouwen
   DO
      Woord$ = INKEY$
      SELECT CASE Woord$
         CASE IS = Omhoog$, Omlaag$, Rechts$, Links$
            CALL PijltjesToetsen
         CASE F1$
            CALL F1HogeMuren
         CASE F2$
            CALL F2Blind
         CASE ELSE
            CALL Seconde
      END SELECT
   LOOP UNTIL Woord$ = Esc$ OR EindeSpel = 1
GOTO verder1


'--------------------------------------------------------------------------
LeesFout:
   PRINT "Fout bij lezen "; BestandsNaam$
   PRINT "Druk op een toets voor programma einde"
   WHILE INKEY$ = ""
   WEND
   END
RETURN

SUB Begin
   REM ---------------Begin akties van het programma---------
Begin:
   SCREEN 9
   COLOR 15, 5            'witte voorgrond, roze achtergrond
   Omhoog$ = CHR$(0) + CHR$(72)
   Omlaag$ = CHR$(0) + CHR$(80)
   Links$ = CHR$(0) + CHR$(75)
   Rechts$ = CHR$(0) + CHR$(77)
   Esc$ = CHR$(27)
   F1$ = CHR$(0) + CHR$(59)
   F2$ = CHR$(0) + CHR$(60)
   RANDOMIZE TIMER
END SUB

SUB BeginScherm
   CLS
PRINT
PRINT "                   Welkom in het Doolhof Programma"
PRINT
PRINT "Met dit programma kunt u in doolhoven van verschillende moeilijkheidsgraad"
PRINT "proberen om het eindpunt te vinden. Uw plaats in het doolhof wordt aangegeven"
PRINT "door een wit blokje. U kunt het blokje verplaatsen m.b.v. de pijltjestoetsen."
PRINT "Het eindpunt wordt aangegeven door een wit cirkeltje."
PRINT "Als er in een doolhof sleuteltjes staan, dan kunt u, door met het witte"
PRINT "blokje over een sleuteltje heen te gaan, dit sleuteltje oppakken en meenemen."
PRINT "Met een sleuteltje kunt u, waar u dat wilt, door een van de muren van het"
PRINT "doolhof heenstappen."
PRINT "Het is de bedoeling dat u probeert met zo weinig mogelijk (straf)punten het"
PRINT "eindpunt te bereiken. Op het scherm staat aangegeven waar u punten voor krijgt"
PRINT "toebedeeld. "
PRINT "Als u de weg een beetje weet door het doolhof, kunt u proberen om met functie-"
PRINT "toetsen F1 of F2 met ng minder punten het eindpunt te bereiken."
PRINT "Om een doolhof te kiezen moet u een nivo aangeven (1, 2 of 3), en daarna"
PRINT "een nummer kiezen uit de lijst doolhoven die u getoond wordt."
PRINT "Bevestig uw keuze(n) met de Enter toets ("; CHR$(17); ")."
PRINT
PRINT "Veel plezier!"
PRINT
PRINT "Druk op een toets om met het spel te beginnen."

END SUB

SUB Diagonaal
    X = 0
    Y = 0
    FOR X = 0 TO AantVakjes
       FOR Y = 0 TO X
          SWAP Hor(X, Y), Ver(Y, X)
          SWAP Ver(X, Y), Hor(Y, X)
          SWAP Sleutels(X, Y), Sleutels(Y, X)
       NEXT Y
       SWAP Hor(X, X), Ver(X, X)
    NEXT X
    SWAP BeginY, BeginX
    SWAP EindeY, EindeX
END SUB

SUB F1HogeMuren
   REM ---------------- wisselen van Gewoon naar Hoge Muren en terug -------
   IF (Blind = 0) THEN  'niet als Blind aktief
      VoorgrondKleur = 0
      CALL ZetNeerHaalWeg 'weghalen op huidige scherm
      IF (HogeMuren = 0) THEN
         HogeMuren = 1
         SCREEN , , 1, 1
         LOCATE 10, 1
         PRINT " F1 - Gewoon     "
         PRINT "                 "
         LOCATE 16, 17
         PRINT "2"
         LOCATE 17, 17
         PRINT "2"
         MuurPunten = 2
         SecondePunten = 2
      ELSE
         HogeMuren = 0
         SCREEN , , 0, 0
         MuurPunten = 3
         SecondePunten = 3
      END IF
      VoorgrondKleur = 15
      CALL ZetNeerHaalWeg 'neerzetten op nieuwe scherm
      CALL ZetPunten
   ELSE
      SOUND 400, 1
   END IF
END SUB

SUB F2Blind
   REM ---------------- wisselen van Gewoon naar Blind en terug -------
   IF (HogeMuren = 0) THEN  'niet als HogeMuren aktief
      VoorgrondKleur = 0
      CALL ZetNeerHaalWeg   'weghalen op oude scherm
      IF (Blind = 0) THEN
         Blind = 1
         SCREEN , , 1, 1
         LOCATE 10, 1
         PRINT "                "
         PRINT " F2 - Gewoon    "
         LOCATE 16, 17
         PRINT "1"
         LOCATE 17, 17
         PRINT "1"
         MuurPunten = 1
         SecondePunten = 1
      ELSE
         Blind = 0
         SCREEN , , 0, 0
         MuurPunten = 3
         SecondePunten = 3
      END IF
      VoorgrondKleur = 15
      CALL ZetNeerHaalWeg   'neerzetten op nieuwe scherm
      CALL ZetPunten
   ELSE
      SOUND 400, 1
   END IF
END SUB

SUB HoofdMenu
BeginHoofdMenu:
   SCREEN , , 0, 0
   CLS
   PRINT "Maak een keuze (1, 2, 3 of 4)"
   PRINT ""
   PRINT "   1  Spelnivo 1, doolhof 20 x 20"
   PRINT "   2  Spelnivo 2, doolhof 27 x 27"
   PRINT "   3  Spelnivo 3, doolhof 36 x 36"
   PRINT "   4  Einde spel"
   PRINT
   INPUT "Uw Keuze ....."; SpelNivo
   IF SpelNivo < 1 THEN GOTO BeginHoofdMenu
   IF SpelNivo > 4 THEN GOTO BeginHoofdMenu
   REM ---------- Maakt alles de zelfde ----------
   IF SpelNivo = 1 THEN
      AantDolen = AantDolen1
      AantVakjes = 20
      FOR i = 1 TO AantDolen
         Dolen$(i) = Dolen1$(i)
      NEXT i
   END IF
   IF SpelNivo = 2 THEN
      AantDolen = AantDolen2
      AantVakjes = 27
      FOR i = 1 TO AantDolen
         Dolen$(i) = Dolen2$(i)
      NEXT i
   END IF
   IF SpelNivo = 3 THEN
      AantDolen = AantDolen3
      AantVakjes = 36
      FOR i = 1 TO AantDolen
         Dolen$(i) = Dolen3$(i)
      NEXT i
   END IF
   IF (SpelNivo <> 4) THEN
      REM ---------- Testen op aantdolen is 0 -------
      IF AantDolen = 0 THEN
         PRINT
         PRINT "Er zijn (nog) geen doolhoven van nivo"; SpelNivo
         PRINT "Druk op een toets"
         WHILE INKEY$ = ""
         WEND
         GOTO BeginHoofdMenu
      END IF
   END IF
END SUB

SUB Horizontaal (X, Y)
   LINE (X * LengteX + 170, Y * LengteY + 12)-STEP(LengteX, 0), VoorgrondKleur
END SUB

SUB LeesDol
   ON ERROR GOTO LeesFout
   IF SpelNivo = 1 THEN BestandsNaam$ = DoolNaam$ + ".DO1"
   IF SpelNivo = 2 THEN BestandsNaam$ = DoolNaam$ + ".DO2"
   IF SpelNivo = 3 THEN BestandsNaam$ = DoolNaam$ + ".DO3"
   OPEN "i", #1, BestandsNaam$
   REM ------ lezen lijst ----------
   ERASE Hor
   ERASE Ver
   ERASE Sleutels
   FOR i = 1 TO 4000 'REM lees max 4000 regels van lijst
      IF EOF(1) THEN GOTO SluitenLijst
      INPUT #1, X, Y, wat$
      IF wat$ = "9" THEN GOTO SluitenLijst 'REM een 9 in kolom 3 geeft einde aan
      SELECT CASE wat$
         CASE "0"
            Hor(X, Y) = 1
         CASE "1"
            Ver(X, Y) = 1
         CASE "s"
            Sleutels(X, Y) = 1
         CASE "b"
            BeginX = X: BeginY = Y
         CASE "e"
            EindeX = X: EindeY = Y
      END SELECT
   NEXT i
SluitenLijst:
   CLOSE #1
   ON ERROR GOTO 0
END SUB

SUB LijstDol
   REM ----------- Maken en lezen lijst .DO? files ------------
   ON ERROR GOTO LeesFout
   BestandsNaam$ = "DOL.DIR"
   SHELL "dir *.do? > dol.dir"
   OPEN "i", #2, "dol.dir"
   FOR i = 1 TO 350
      IF EOF(2) THEN GOTO EindeLijstDo
      INPUT #2, regel$
      Lengte = INSTR(1, regel$, " ")
      IF (Lengte > 1 AND Lengte < 10) THEN  'veiligheidstest
         IF MID$(regel$, 10, 3) = "DO1" THEN
            IF (AantDolen1 < 100) THEN
               AantDolen1 = AantDolen1 + 1
               Dolen1$(AantDolen1) = LEFT$(regel$, Lengte - 1)
            END IF
         END IF
         IF MID$(regel$, 10, 3) = "DO2" THEN
            IF (AantDolen2 < 100) THEN
               AantDolen2 = AantDolen2 + 1
               Dolen2$(AantDolen2) = LEFT$(regel$, Lengte - 1)
            END IF
         END IF
         IF MID$(regel$, 10, 3) = "DO3" THEN
            IF (AantDolen3 < 100) THEN
               AantDolen3 = AantDolen3 + 1
               Dolen3$(AantDolen3) = LEFT$(regel$, Lengte - 1)
            END IF
         END IF
      END IF
   NEXT i
EindeLijstDo:
   CLOSE #2
   ON ERROR GOTO 0
   REM -------------- wacht tot gebruiker het beginscherm heeft gelezen ---
   WHILE INKEY$ = ""
   WEND
END SUB

SUB LinksRechts
    DeHelft = (AantVakjes - 1) \ 2
    FOR X = 0 TO DeHelft
       FOR Y = 0 TO AantVakjes
          SWAP Hor(X, Y), Hor(AantVakjes - X - 1, Y)
          SWAP Ver(X, Y), Ver(AantVakjes - X, Y)
          SWAP Sleutels(X, Y), Sleutels(AantVakjes - X - 1, Y)
       NEXT Y
    NEXT X
    BeginX = AantVakjes - BeginX - 1
    EindeX = AantVakjes - EindeX - 1
END SUB

SUB OndersteBoven
    DeHelft = (AantVakjes - 1) \ 2
    FOR X = 0 TO AantVakjes
       FOR Y = 0 TO DeHelft
          SWAP Hor(X, Y), Hor(X, AantVakjes - Y)
          SWAP Ver(X, Y), Ver(X, AantVakjes - Y - 1)
          SWAP Sleutels(X, Y), Sleutels(X, AantVakjes - Y - 1)
       NEXT Y
    NEXT X
    BeginY = AantVakjes - BeginY - 1
    EindeY = AantVakjes - EindeY - 1
END SUB

SUB PijltjesToetsen
   REM ---------- Testen of verplaatsing in gewenste richting is toegestaan ----
   SleutelGebruiken = 0
   IF Woord$ = Omhoog$ THEN
      IF Hor(LoperX, LoperY) = 1 THEN
         IF SleutelsMee = 0 THEN GOTO VerplaatsError
         SleutelGebruiken = 1
      END IF
      LoperYNieuw = LoperY - 1
      LoperXNieuw = LoperX
   END IF
   IF Woord$ = Omlaag$ THEN
      IF Hor(LoperX, LoperY + 1) = 1 THEN
         IF SleutelsMee = 0 THEN GOTO VerplaatsError
         SleutelGebruiken = 1
      END IF
      LoperYNieuw = LoperY + 1
      LoperXNieuw = LoperX
   END IF
   IF Woord$ = Rechts$ THEN
      IF Ver(LoperX + 1, LoperY) = 1 THEN
         IF SleutelsMee = 0 THEN GOTO VerplaatsError
         SleutelGebruiken = 1
      END IF
      LoperXNieuw = LoperX + 1
      LoperYNieuw = LoperY
   END IF
   IF Woord$ = Links$ THEN
      IF Ver(LoperX, LoperY) = 1 THEN
         IF SleutelsMee = 0 THEN GOTO VerplaatsError
         SleutelGebruiken = 1
      END IF
      LoperXNieuw = LoperX - 1
      LoperYNieuw = LoperY
   END IF
   IF LoperXNieuw < 0 OR LoperXNieuw > AantVakjes - 1 THEN GOTO VerplaatsError
   IF LoperYNieuw < 0 OR LoperYNieuw > AantVakjes - 1 THEN GOTO VerplaatsError
   VoorgrondKleur = 0
   CALL ZetNeerHaalWeg 'weghalen op oude plaats
   LoperX = LoperXNieuw
   LoperY = LoperYNieuw
   IF SleutelGebruiken = 1 THEN
      SleutelsMee = 0
      Punten = Punten + 10
   END IF
   VoorgrondKleur = 15
   CALL ZetNeerHaalWeg ' neerzetten op nieuwe plaats
   Punten = Punten + 1
   CALL ZetPunten
   REM -------- Test of er een sleutel is op de nieuwe plaats -------
   IF Sleutels(LoperX, LoperY) = 1 THEN
      IF SleutelsMee = 0 THEN
         SleutelsMee = 1
         Sleutels(LoperX, LoperY) = 0
         IF (HogeMuren = 1 OR Blind = 1) THEN 'bijwerken andere scherm
            SCREEN , , 0, 1                   ' ivm opgepakte sleutel
            CALL ZetHaalSleutel(LoperX, LoperY)
            SCREEN , , 1, 1
         END IF
      END IF
   END IF
   REM -------- Test of cursor is op eindplaats ----------
   IF (EindeX = LoperX AND EindeY = LoperY) THEN
      IF (Blind = 1 OR HogeMuren = 1) THEN
         CALL ZetHaalRondje(LoperX, LoperY)
      END IF
      LOCATE 22, 1
      PRINT "U had"; Punten; "punten nodig !"
      PRINT "Druk op ESC"
      FOR i = 400 TO 1000 STEP 75
         SOUND i, 1
      NEXT i
      WHILE INKEY$ <> Esc$
      WEND
      CLS
      EindeSpel = 1
   END IF
   GOTO EindePijltjes
VerplaatsError:
   Punten = Punten + MuurPunten
   CALL ZetPunten
   SOUND 400, 1
EindePijltjes:
END SUB

SUB SchermTekenen
   REM ------- Scherm opbouwen ------------------------------
   VoorgrondKleur = 15 'rem wit
   EindeSpel = 0
   Punten = 0
   MuurPunten = 3
   SecondePunten = 3
   SleutelsMee = 0
   Blind = 0
   HogeMuren = 0
   REM -------------- evt. verdraaien/omkeren doolhof -------
   willekeurig = RND * 4
   IF (willekeurig = 1) THEN
      CALL OndersteBoven
   END IF
   IF (willekeurig = 2) THEN
      CALL LinksRechts
   END IF
   IF (willekeurig = 3) THEN
      CALL Diagonaal
   END IF
   LoperX = BeginX 'dit pas doen na het evt. omdraaien
   LoperY = BeginY
   REM --------------------- loper en sleutel tekenen --------
   SCREEN , , 1, 0  'werk tijdelijk op andere scherm
   CLS
   IF SpelNivo = 1 THEN
      LengteX = 21
      LengteY = 16
      CIRCLE (10, 58), 7 'teken rondje
      PAINT (10, 58), 15, 15
      PSET (6, 7) 'beginpunt voor sleuteltje
   END IF
   IF SpelNivo = 2 THEN
      LengteX = 16
      LengteY = 12
      CIRCLE (8, 56), 4
      PAINT (8, 56), 15, 15
      PSET (4, 5)
   END IF
   IF SpelNivo = 3 THEN
      LengteX = 12
      LengteY = 9
      CIRCLE (6, 55), 3
      PAINT (6, 55), 15, 15
      PSET (2, 4)
   END IF
   DRAW "d3 r1 u2 r4 d1 r1 d1 r1 u1 r1 u3 l1 u1 l1 d1 l1 d1 l4"'sleutel!
   GET (1, 1)-STEP(LengteX - 2, LengteY - 2), Sleutel
   LINE (102, 102)-STEP(LengteX - 4, LengteY - 4), , BF
   GET (101, 101)-STEP(LengteX - 2, LengteY - 2), Loper
   GET (1, 51)-STEP(LengteX - 2, LengteY - 2), Rondje
   REM ------------ bouw achtergrondscherm op voor blind/hoge muren --------
   CLS
   CALL SchermTeksten
   REM --------- terug naar scherm 0 -------------
   SCREEN , , 0, 0
   CLS
   FOR i = 0 TO AantVakjes
      FOR j = 0 TO AantVakjes
         IF Hor(i, j) = 1 THEN CALL Horizontaal(i, j)
         IF Ver(i, j) = 1 THEN CALL Verticaal(i, j)
         IF Sleutels(i, j) = 1 THEN CALL ZetHaalSleutel(i, j)
      NEXT j
   NEXT i
   CALL ZetHaalLoper(BeginX, BeginY)
   CALL ZetHaalRondje(EindeX, EindeY)
   CALL SchermTeksten
END SUB

SUB SchermTeksten
   REM ------------- vaste teksten op het scherm
   LOCATE 2, 1
   PRINT " Spelnivo :"; SpelNivo
   PRINT " Doolhof  : "; DoolNaam$
   LOCATE 5, 1
   PRINT " ESC = Stoppen";
   LOCATE 7, 1
   PRINT " Pijltjes Toetsen"
   LOCATE 8, 1
   PRINT "     = Verschuiven"
   LOCATE 10, 1
   PRINT " F1 - Hoge Muren"
   PRINT " F2 - Blind"
   LOCATE 13, 1
   PRINT " Per         Punten"
   PRINT " ------      ------"
   PRINT " Stap           1"
   PRINT " Seconde        3"
   PRINT " Muur           3"
   PRINT " Sleutel       10"
   LOCATE 20, 1
   PRINT " Uw punten :"
END SUB

SUB Seconde
   tijdnieuw$ = TIME$
   IF (tijdnieuw$ <> TijdOud$) THEN
      TijdOud$ = tijdnieuw$
      Punten = Punten + SecondePunten
      CALL ZetPunten
   END IF
END SUB

SUB SleutelRondje (X, Y)
      IF (Sleutels(X, Y) = 1) THEN
         CALL ZetHaalSleutel(X, Y)
      END IF
      IF ((X = EindeX) AND (Y = EindeY)) THEN
         CALL ZetHaalRondje(X, Y)
      END IF
END SUB

SUB TonenLijst
   REM ----------- Tonen lijsten, vragen om keuze --------------
TekleinOfTegroot:
   PRINT : PRINT "Kies een doolhof:": PRINT
   Tel = 0
   FOR i = 1 TO AantDolen
      PRINT TAB((Tel) * 15);
      PRINT USING "### "; i;
      PRINT Dolen$(i);
      Tel = Tel + 1
      IF Tel = 5 THEN Tel = 0
   NEXT i
   PRINT : PRINT
   INPUT "Welk doolhof ....."; DoolKeuze
   IF DoolKeuze > AantDolen THEN PRINT "Te groot": GOTO TekleinOfTegroot
   IF DoolKeuze < 1 THEN PRINT "Te klein": GOTO TekleinOfTegroot
   DoolNaam$ = Dolen$(DoolKeuze)
END SUB

SUB Verticaal (X, Y)
    LINE ((X * LengteX + 170), (Y * LengteY + 12))-STEP(0, LengteY), VoorgrondKleur
END SUB

SUB ZetHaalBlind
   IF (Hor(LoperX, LoperY) = 1) THEN                       'lijntje boven ?
      CALL Horizontaal(LoperX, LoperY)
   ELSE
      IF (Sleutels(LoperX, LoperY - 1) = 1) THEN           'sleuteltje boven ?
         CALL ZetHaalSleutel(LoperX, LoperY - 1)
      END IF
      IF ((LoperX = EindeX) AND (LoperY - 1 = EindeY)) THEN 'rondje boven?
         CALL ZetHaalRondje(LoperX, LoperY - 1)
      END IF
   END IF
  
   IF (Hor(LoperX, LoperY + 1) = 1) THEN                   'lijntje onder ?
      CALL Horizontaal(LoperX, LoperY + 1)
   ELSE
      IF (Sleutels(LoperX, LoperY + 1) = 1) THEN           'sleuteltje onder ?
         CALL ZetHaalSleutel(LoperX, LoperY + 1)
      END IF
      IF ((LoperX = EindeX) AND (LoperY + 1 = EindeY)) THEN 'enz
         CALL ZetHaalRondje(LoperX, LoperY + 1)
      END IF
   END IF
  
   IF (Ver(LoperX, LoperY) = 1) THEN                       'lijntje links?
      CALL Verticaal(LoperX, LoperY)
   ELSE
      IF (Sleutels(LoperX - 1, LoperY) = 1) THEN
         CALL ZetHaalSleutel(LoperX - 1, LoperY)
      END IF
      IF ((LoperX - 1 = EindeX) AND (LoperY = EindeY)) THEN
         CALL ZetHaalRondje(LoperX - 1, LoperY)
      END IF
   END IF
  
   IF (Ver(LoperX + 1, LoperY) = 1) THEN
      CALL Verticaal(LoperX + 1, LoperY)
   ELSE
      IF (Sleutels(LoperX + 1, LoperY) = 1) THEN
         CALL ZetHaalSleutel(LoperX + 1, LoperY)
      END IF
      IF ((LoperX + 1 = EindeX) AND (LoperY = EindeY)) THEN
         CALL ZetHaalRondje(LoperX + 1, LoperY)
      END IF
   END IF
END SUB

SUB ZetHaalHogeMuren
REM
REM ---- weghalen/neerzetten muren/sleutels/eindpunt tbv HogeMuren
REM
REM   Onderstaand schema geeft aan welke muren/sleutels evt. getoond
REM   worden bij spelstand HogeMuren.
REM   De aangegeven cordinaten zijn relatief t.o.v. de plaats van de loper.
REM   Voor het NoordWest-NoordOost kwartier is door de doorlopende lijnen
REM   aangegeven welke muren 'zichtbaar' zijn als andere, dichterbij staande,
REM   muren er 'niet zijn'.
REM   Bijvoorbeeld: als de horizontale muur (0,0) er niet is, dan worden
REM   getoond, indien aanwezig: Sleutel(0,-1),Verticale Muren (0,-1) en (1,-1)
REM   en HorizontaleMuur(0,-1).
REM
REM   NoordWest                                               NoordOost
REM               (-1,-2)----(0,-2)-----(1,-2)-----(2,-2)
REM                 |          |          |          |
REM                 S      SĴ     SĴ
REM                 |          |          |          |
REM   (-2,-1)---- (-1,-1)----(0,-1)-----(1,-1)-----(2,-1)------(3,-1)
REM     |           |          |          |          |           |
REM     |     S     |     S     |     S     |
REM     |           |           |          |           |           |
REM   (-2,0)------(-1,0)------(0,0)------(1,0)-------(2,0)-------(3,0)
REM     |           |           | XXXXXXXX  |           |           |
REM     |     S     |     S     | XXXXXXXX  |     S     |     S     |
REM     |           |           | XXXXXXXX  |           |           |
REM   (-2,1)------(-1,1)------(0,1)-------(1,1)-------(2,1)-------(3,1)
REM     |           |           |           |           |           |
REM     |     S     |     *     |     S     |     *     |     S     |
REM     |           |           |           |           |           |
REM   (-2,2)------(-1,2)------(0,2)-------(1,2)-------(2,2)-------(3,2)
REM                 |           |           |           |
REM                 |     S     |     S     |     S     |
REM                 |           |           |           |
REM               (-1,3)      (0,3)-------(1,3)       (2,3)   
REM   ZuidWest                                                  ZuidOost
REM
REM   De evt. Sleutels grenzend aan de hoekpunten spelen een aparte rol.
REM   Bijvoorbeeld:
REM   Sleutel(-1,-1) is zichtbaar als,
REM   -   Verticale Lijn (0,-1) n Horizontale Lijn (0,0) afwezig, f
REM   -   Horizontale Lijn (-1,0) n Verticale Lijn (0,0) afwezig.
REM
REM               (-1,-1)-----(0,-1)------(1,-1)------(2,-1)    
REM                 |           |           |           |
REM                 |     SĿ       |     S     |
REM                 |          |          |           |
REM               (-1,0)-----(0,0)------(1,0)-------(2,0)
REM                 |     Ĵ XXXXXXXX  |           |  
REM                 |           | XXXXXXXX  |           |   
REM                 |           | XXXXXXXX  |           |   
REM               (-1,1)------(0,1)-------(1,1)-------(2,1)   
REM                 |           |           |           |
REM                 |     S     |           |     S     |
REM                 |           |           |           | 
REM               (-1,2)------(0,2)-------(1,2)-------(2,2)   
REM
REM
   REM --------NoordWest --- NoordOost-----------
   IF (Hor(LoperX, LoperY) = 1) THEN
      CALL Horizontaal(LoperX, LoperY)
   ELSE
       CALL SleutelRondje(LoperX, LoperY - 1)
       IF (Ver(LoperX, LoperY - 1) = 1) THEN
          CALL Verticaal(LoperX, LoperY - 1)
       ELSE
           IF (Hor(LoperX - 1, LoperY - 1)) THEN
              CALL Horizontaal(LoperX - 1, LoperY - 1)
           ELSE
              CALL SleutelRondje(LoperX - 1, LoperY - 2)
              IF (Ver(LoperX - 1, LoperY - 2) = 1) THEN
                 CALL Verticaal(LoperX - 1, LoperY - 2)
              END IF
              IF (Hor(LoperX - 1, LoperY - 2) = 1) THEN
                 CALL Horizontaal(LoperX - 1, LoperY - 2)
              END IF
           END IF
       END IF
       IF (Hor(LoperX, LoperY - 1) = 1) THEN
          CALL Horizontaal(LoperX, LoperY - 1)
       ELSE
          CALL SleutelRondje(LoperX, LoperY - 2)
          IF (Ver(LoperX, LoperY - 2) = 1) THEN
             CALL Verticaal(LoperX, LoperY - 2)
          END IF
          IF (Hor(LoperX, LoperY - 2) = 1) THEN
             CALL Horizontaal(LoperX, LoperY - 2)
          END IF
          IF (Ver(LoperX + 1, LoperY - 2) = 1) THEN
             CALL Verticaal(LoperX + 1, LoperY - 2)
          END IF
       END IF
       IF (Ver(LoperX + 1, LoperY - 1) = 1) THEN
          CALL Verticaal(LoperX + 1, LoperY - 1)
       ELSE
           IF (Hor(LoperX + 1, LoperY - 1)) THEN
              CALL Horizontaal(LoperX + 1, LoperY - 1)
           ELSE
              CALL SleutelRondje(LoperX + 1, LoperY - 2)
              IF (Hor(LoperX + 1, LoperY - 2) = 1) THEN
                 CALL Horizontaal(LoperX + 1, LoperY - 2)
              END IF
              IF (Ver(LoperX + 2, LoperY - 2) = 1) THEN
                 CALL Verticaal(LoperX + 2, LoperY - 2)
              END IF
           END IF
       END IF

   END IF

   REM --------NoordOost--- ZuidOost -----------
   IF (Ver(LoperX + 1, LoperY) = 1) THEN
      CALL Verticaal(LoperX + 1, LoperY)
   ELSE
       CALL SleutelRondje(LoperX + 1, LoperY)
       IF (Hor(LoperX + 1, LoperY) = 1) THEN
          CALL Horizontaal(LoperX + 1, LoperY)
       ELSE
           IF (Ver(LoperX + 2, LoperY - 1)) THEN
              CALL Verticaal(LoperX + 2, LoperY - 1)
           ELSE
              CALL SleutelRondje(LoperX + 2, LoperY - 1)
              IF (Hor(LoperX + 2, LoperY - 1) = 1) THEN
                 CALL Horizontaal(LoperX + 2, LoperY - 1)
              END IF
              IF (Ver(LoperX + 3, LoperY - 1) = 1) THEN
                 CALL Verticaal(LoperX + 3, LoperY - 1)
              END IF
          END IF
       END IF
       IF (Ver(LoperX + 2, LoperY) = 1) THEN
          CALL Verticaal(LoperX + 2, LoperY)
       ELSE
          CALL SleutelRondje(LoperX + 2, LoperY)
          IF (Hor(LoperX + 2, LoperY) = 1) THEN
             CALL Horizontaal(LoperX + 2, LoperY)
          END IF
          IF (Ver(LoperX + 3, LoperY) = 1) THEN
             CALL Verticaal(LoperX + 3, LoperY)
          END IF
          IF (Hor(LoperX + 2, LoperY + 1) = 1) THEN
             CALL Horizontaal(LoperX + 2, LoperY + 1)
          END IF
       END IF
       IF (Hor(LoperX + 1, LoperY + 1) = 1) THEN
          CALL Horizontaal(LoperX + 1, LoperY + 1)
       ELSE
           IF (Ver(LoperX + 2, LoperY + 1) = 1) THEN
              CALL Verticaal(LoperX + 2, LoperY + 1)
           ELSE
              CALL SleutelRondje(LoperX + 2, LoperY + 1)
              IF (Ver(LoperX + 3, LoperY + 1) = 1) THEN
                 CALL Verticaal(LoperX + 3, LoperY + 1)
              END IF
              IF (Hor(LoperX + 2, LoperY + 2) = 1) THEN
                 CALL Horizontaal(LoperX + 2, LoperY + 2)
              END IF
           END IF
       END IF
    END IF
          
   REM --------ZuidWest --- ZuidOost -----------
   IF (Hor(LoperX, LoperY + 1) = 1) THEN
      CALL Horizontaal(LoperX, LoperY + 1)
   ELSE
       CALL SleutelRondje(LoperX, LoperY + 1)
       IF (Ver(LoperX, LoperY + 1) = 1) THEN
          CALL Verticaal(LoperX, LoperY + 1)
       ELSE
           IF (Hor(LoperX - 1, LoperY + 2)) THEN
              CALL Horizontaal(LoperX - 1, LoperY + 2)
           ELSE
              CALL SleutelRondje(LoperX - 1, LoperY + 2)
              IF (Ver(LoperX - 1, LoperY + 2) = 1) THEN
                 CALL Verticaal(LoperX - 1, LoperY + 2)
              END IF
              IF (Hor(LoperX - 1, LoperY + 3) = 1) THEN
                 CALL Horizontaal(LoperX - 1, LoperY + 3)
              END IF
           END IF
       END IF
       IF (Hor(LoperX, LoperY + 2) = 1) THEN
          CALL Horizontaal(LoperX, LoperY + 2)
       ELSE
          CALL SleutelRondje(LoperX, LoperY + 2)
          IF (Ver(LoperX, LoperY + 2) = 1) THEN
             CALL Verticaal(LoperX, LoperY + 2)
          END IF
          IF (Hor(LoperX, LoperY + 3) = 1) THEN
             CALL Horizontaal(LoperX, LoperY + 3)
          END IF
          IF (Ver(LoperX + 1, LoperY + 2) = 1) THEN
             CALL Verticaal(LoperX + 1, LoperY + 2)
          END IF
       END IF
       IF (Ver(LoperX + 1, LoperY + 1) = 1) THEN
          CALL Verticaal(LoperX + 1, LoperY + 1)
       ELSE
           IF (Hor(LoperX + 1, LoperY + 2)) THEN
              CALL Horizontaal(LoperX + 1, LoperY + 2)
           ELSE
              CALL SleutelRondje(LoperX + 1, LoperY + 2)
              IF (Hor(LoperX + 1, LoperY + 3) = 1) THEN
                 CALL Horizontaal(LoperX + 1, LoperY + 3)
              END IF
              IF (Ver(LoperX + 2, LoperY + 2) = 1) THEN
                 CALL Verticaal(LoperX + 2, LoperY + 2)
              END IF
           END IF
       END IF
    END IF
  
   REM --------NoordWest--- ZuidWest -----------
   IF (Ver(LoperX, LoperY) = 1) THEN
      CALL Verticaal(LoperX, LoperY)
   ELSE
       CALL SleutelRondje(LoperX - 1, LoperY)
       IF (Hor(LoperX - 1, LoperY) = 1) THEN
          CALL Horizontaal(LoperX - 1, LoperY)
       ELSE
           IF (Ver(LoperX - 1, LoperY - 1)) THEN
              CALL Verticaal(LoperX - 1, LoperY - 1)
           ELSE
              CALL SleutelRondje(LoperX - 2, LoperY - 1)
              IF (Hor(LoperX - 2, LoperY - 1) = 1) THEN
                 CALL Horizontaal(LoperX - 2, LoperY - 1)
              END IF
              IF (Ver(LoperX - 2, LoperY - 1) = 1) THEN
                 CALL Verticaal(LoperX - 2, LoperY - 1)
              END IF
           END IF
       END IF
       IF (Ver(LoperX - 1, LoperY) = 1) THEN
          CALL Verticaal(LoperX - 1, LoperY)
       ELSE
          CALL SleutelRondje(LoperX - 2, LoperY)
          IF (Hor(LoperX - 2, LoperY) = 1) THEN
             CALL Horizontaal(LoperX - 2, LoperY)
          END IF
          IF (Ver(LoperX - 2, LoperY) = 1) THEN
             CALL Verticaal(LoperX - 2, LoperY)
          END IF
          IF (Hor(LoperX - 2, LoperY + 1) = 1) THEN
             CALL Horizontaal(LoperX - 2, LoperY + 1)
          END IF
       END IF
       IF (Hor(LoperX - 1, LoperY + 1) = 1) THEN
          CALL Horizontaal(LoperX - 1, LoperY + 1)
       ELSE
           IF (Ver(LoperX - 1, LoperY + 1) = 1) THEN
              CALL Verticaal(LoperX - 1, LoperY + 1)
           ELSE
              CALL SleutelRondje(LoperX - 2, LoperY + 1)
              IF (Ver(LoperX - 2, LoperY + 1) = 1) THEN
                 CALL Verticaal(LoperX - 2, LoperY + 1)
              END IF
              IF (Hor(LoperX - 2, LoperY + 2) = 1) THEN
                 CALL Horizontaal(LoperX - 2, LoperY + 2)
              END IF
           END IF
       END IF
    END IF
        
    REM -------- nu nog de vakjes op de vier hoekpunten
    REM ----- NoordWest --------
    IF (Hor(LoperX - 1, LoperY) = 0 AND Ver(LoperX, LoperY) = 0) OR (Ver(LoperX, LoperY - 1) = 0 AND Hor(LoperX, LoperY) = 0) THEN
       CALL SleutelRondje(LoperX - 1, LoperY - 1)
    END IF
    REM ----- NoordOost ----------
    IF (Hor(LoperX, LoperY) = 0 AND Ver(LoperX + 1, LoperY - 1) = 0) OR (Ver(LoperX + 1, LoperY) = 0 AND Hor(LoperX + 1, LoperY) = 0) THEN
       CALL SleutelRondje(LoperX + 1, LoperY - 1)
    END IF
    REM ----- ZuidOost ----------
    IF (Hor(LoperX, LoperY + 1) = 0 AND Ver(LoperX + 1, LoperY + 1) = 0) OR (Ver(LoperX + 1, LoperY) = 0 AND Hor(LoperX + 1, LoperY + 1) = 0) THEN
       CALL SleutelRondje(LoperX + 1, LoperY + 1)
    END IF
    REM ----- ZuidWest ----------
    IF (Hor(LoperX, LoperY + 1) = 0 AND Ver(LoperX, LoperY + 1) = 0) OR (Ver(LoperX, LoperY) = 0 AND Hor(LoperX - 1, LoperY + 1) = 0) THEN
       CALL SleutelRondje(LoperX - 1, LoperY + 1)
    END IF
 
END SUB

SUB ZetHaalLoper (X, Y)
   PUT (X * LengteX + 171, Y * LengteY + 13), Loper
END SUB

SUB ZetHaalRondje (X, Y)
   PUT (X * LengteX + 171, Y * LengteY + 13), Rondje
END SUB

SUB ZetHaalSleutel (X, Y)
   PUT (X * LengteX + 171, Y * LengteY + 13), Sleutel
END SUB

SUB ZetNeerHaalWeg
   CALL ZetHaalLoper(LoperX, LoperY)
   IF SleutelsMee = 1 THEN
      CALL ZetHaalSleutel(LoperX, LoperY)
   END IF
   IF (Blind = 1) THEN
      CALL ZetHaalBlind
      IF (Sleutels(LoperX, LoperY) = 1) THEN
         CALL ZetHaalSleutel(LoperX, LoperY)
      END IF
   END IF
   IF (HogeMuren = 1) THEN
      CALL ZetHaalHogeMuren
      IF (Sleutels(LoperX, LoperY) = 1) THEN
         CALL ZetHaalSleutel(LoperX, LoperY)
      END IF
   END IF
END SUB

SUB ZetPunten
   LOCATE 20, 13
   PRINT USING " ####"; Punten
END SUB

