' getvram.bas       qb4/pdq     w p woodall         03-18-90
'
' Copyright (c) 1990 W P Woodall. All Rights Reserved.
'
' copy video ram [text modes only] into text file.
' by request from a vbbs-pc sysop.

DEFINT A-Z

'$INCLUDE: 'PDQDECL.DEF'

DIM regs AS RegType

' ******** define local functions ********

DEF FNgetvmode (vpage)
    ' function returns current video mode, changes vpage to reflect reality
    regs.AX = &HF00
    CALL Interrupt(&H10, regs)
    vpage = regs.BX
    FNgetvmode = regs.AX AND &H00FF
END DEF

DEF FNreadchar (vpage)
    ' function returns character at current cursor position
    regs.AX = &H800
    regs.BX = vpage
    CALL Interrupt(&H10, regs)
    FNreadchar = regs.AX AND &H00FF
END DEF

DEF FNcpos (vpage, row, col)
    ' function sets cursor position
    regs.AX = &H200
    regs.BX = vpage
    regs.DX = col + (256 * row)
    CALL Interrupt(&H10, regs)
END DEF

' --------  end function defines -------

mainstart:
    vpage = 0
    scr$ = ""
    x = FNgetvmode(vpage)
    validmode=(x=2)+(x=3)+(x=7)
    IF NOT validmode THEN
        ' we don't do graphics this time out...
        END
    END IF
    FOR row = 0 TO 24
        FOR col = 0 TO 78
            z = FNcpos(vpage,row,col)
            c = FNreadchar(vpage)
            scr$ = scr$ + CHR$(c)
        NEXT col
        scr$ = scr$ + CHR$(13) + CHR$(10)
    NEXT row
    PRINT scr$;




