# printed circuit board autorouter, viewer, and printer

.c.obj:
	cl /G2s /Oat /W3 /Zp /c $*.c

.asm.obj:
	masm /t /ml $*.asm;

pcbroute.obj: pcbroute.c cell.h

io.obj: io.c cell.h

solve.obj: solve.c cell.h

board.obj: board.c cell.h

queue.obj: queue.c cell.h

work.obj: work.c cell.h

dist.obj: dist.c cell.h

alloc.obj: alloc.c

pcbroute.lnk: makefile
	echo pcbroute io solve board queue work dist alloc >pcbroute.lnk
	echo pcbroute.exe /noi >>pcbroute.lnk
	echo pcbroute.map /m; >>pcbroute.lnk

pcbroute.exe: pcbroute.obj io.obj solve.obj board.obj queue.obj work.obj \
		dist.obj alloc.obj pcbroute.lnk
	link @pcbroute.lnk

pcbview.obj: pcbview.c cell.h

bitmap.obj: bitmap.c cell.h bitmap1.h bitmap2.h bitmap3.h

util.obj: util.asm

pcbview.lnk: makefile
	echo pcbview bitmap board alloc util >pcbview.lnk
	echo pcbview.exe /noi >>pcbview.lnk
	echo pcbview.map /m; >>pcbview.lnk

pcbview.exe: pcbview.obj bitmap.obj board.obj alloc.obj util.obj pcbview.lnk
	link @pcbview.lnk

pcbprint.obj: pcbprint.c cell.h

pcbprint.lnk: makefile
	echo pcbprint bitmap board alloc >pcbprint.lnk
	echo pcbprint.exe /noi >>pcbprint.lnk
	echo pcbprint.map /m; >>pcbprint.lnk

pcbprint.exe: pcbprint.obj bitmap.obj board.obj alloc.obj pcbprint.lnk
	link @pcbprint.lnk
